VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Scrollable in Cell Editing of a Grid Demo"
   ClientHeight    =   3225
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8235
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9.75
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   3225
   ScaleWidth      =   8235
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   18
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   1920
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   2040
      Width           =   2175
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1695
      LargeChange     =   3
      Left            =   6720
      Max             =   100
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin VB.TextBox Text1 
      BackColor       =   &H00C0FFFF&
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   480
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   480
      Width           =   1215
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   1695
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   0
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   2990
      _Version        =   393216
      Rows            =   4
      Cols            =   5
      BackColorFixed  =   12648384
      ScrollBars      =   0
      AllowUserResizing=   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Current_Row As Integer
Private Current_Column As Integer

Private Move_Up As Boolean
Private Move_Down As Boolean
Private Move_Left As Boolean
Private Move_Right As Boolean

Private Const First_Row = 1
Private Const First_Column = 1
Private Const Max_Row = 3
Private Const Max_Column = 4

Private Const Column0 = 0
Private Const Column1 = 1
Private Const Column2 = 2
Private Const Numeric_Column = 3
Private Const Column4 = 4
'Private Const Column5 = 5

Private Type My_Array_Type
   Array_Column0 As String
   Array_Column1 As String
   Array_Column2 As String
   Array_Numeric_Column As String
   Array_Column4 As String
End Type

Private My_Array(First_Row To 103) As My_Array_Type
Private My_Array_Pointer As Integer
Private Do_It As Boolean
Private CharacterWidth As Single
Private A_Numeric_Column As Boolean

Private Sub Move_To_Cell()

    'Take the Data in the text Box and Write it into the
    'Under Laying Cell
    MSFlexGrid1.Text = Text1.Text
    
    If Move_Up Then
        Move_Up = False
        If Current_Row = First_Row Then
            GoSub Shift_Grid_Down
        ElseIf Current_Row > First_Row Then
            Current_Row = Current_Row - 1
        End If
        
    ElseIf Move_Down Then
        Move_Down = False
        If Current_Row = Max_Row Then
            GoSub Shift_Grid_Up
        ElseIf Current_Row < Max_Row Then
            Current_Row = Current_Row + 1
        End If
        
    ElseIf Move_Left Then
        Move_Left = False
        If Current_Column = First_Column Then
            If Current_Row = First_Row Then
                If My_Array_Pointer > 0 Then
                    GoSub Shift_Grid_Down
    '                Current_Row = Max_Row
                    Current_Column = Max_Column
                End If
            ElseIf Current_Row > First_Row Then
                Current_Row = Current_Row - 1
                Current_Column = Max_Column
            End If
        ElseIf Current_Column > 0 Then
            Current_Column = Current_Column - 1
        End If
        
    ElseIf Move_Right Then
        Move_Right = False
        If Current_Column = Max_Column Then
            If Current_Row = Max_Row Then
                If My_Array_Pointer < 99 Then
                    GoSub Shift_Grid_Up
    '                Current_Row = First_Row
                    Current_Column = First_Column
                End If
            ElseIf Current_Row < Max_Row Then
                Current_Row = Current_Row + 1
                Current_Column = First_Column
            End If
        ElseIf Current_Column < Max_Column Then
            Current_Column = Current_Column + 1
        End If
        
    Else
    End If
        
    Call Move_The_Text_Box
    
Exit Sub

'==========================================
Shift_Grid_Up:
    Call Copy_Grid_To_Array
    My_Array_Pointer = My_Array_Pointer + 1
    Do_It = False
    If VScroll1.Value < 100 Then VScroll1.Value = VScroll1.Value + 1
    Do_It = True
    If My_Array_Pointer > 100 Then My_Array_Pointer = 100
    Call Copy_Array_To_Grid
Return

'==========================================
Shift_Grid_Down:
    Call Copy_Grid_To_Array
    My_Array_Pointer = My_Array_Pointer - 1
    Do_It = False
    If VScroll1.Value > 0 Then VScroll1.Value = VScroll1.Value - 1
    Do_It = True
    If My_Array_Pointer < 0 Then My_Array_Pointer = 0
    Call Copy_Array_To_Grid
Return

End Sub

Private Sub Move_The_Text_Box()
Dim A As String

    MSFlexGrid1.Row = Current_Row
    MSFlexGrid1.Col = Current_Column
       
    Text1.Top = MSFlexGrid1.Top + MSFlexGrid1.CellTop
    Text1.Left = MSFlexGrid1.Left + MSFlexGrid1.CellLeft
    
    Text1.Height = MSFlexGrid1.CellHeight
    Text1.Width = MSFlexGrid1.CellWidth
    Text1.MaxLength = (Text1.Width / CharacterWidth) - 1 'Less than BoxSize
    
    'Put The Underlaying data in the Text.box
    If Current_Column = Numeric_Column Then
        A_Numeric_Column = True
        A$ = Space$(Text1.MaxLength)
        Mid$(A$, Text1.MaxLength - Len(Trim$(MSFlexGrid1.Text))) = Trim$(MSFlexGrid1.Text)
        Text1.Text = A$
    Else
        A_Numeric_Column = False
        Text1.Text = Trim$(MSFlexGrid1.Text)
    End If
    
End Sub

Private Sub Copy_Grid_To_Array()
Dim I As Integer
Dim J As Integer

    MSFlexGrid1.Visible = False
    For I% = First_Row To Max_Row
        MSFlexGrid1.Row = I%
        For J% = 0 To Max_Column
            MSFlexGrid1.Col = J%
            Select Case MSFlexGrid1.Col
                Case Column0
                    My_Array(I% + My_Array_Pointer).Array_Column0 = Trim$(MSFlexGrid1.Text)
                Case Column1
                    My_Array(I% + My_Array_Pointer).Array_Column1 = Trim$(MSFlexGrid1.Text)
                Case Column2
                    My_Array(I% + My_Array_Pointer).Array_Column2 = Trim$(MSFlexGrid1.Text)
                Case Numeric_Column
                    My_Array(I% + My_Array_Pointer).Array_Numeric_Column = Trim$(MSFlexGrid1.Text)
                Case Column4
                    My_Array(I% + My_Array_Pointer).Array_Column4 = Trim$(MSFlexGrid1.Text)
            End Select
        Next J%
    Next I%
    
End Sub

Private Sub Copy_Array_To_Grid()
Dim I As Integer
Dim J As Integer

    For I% = First_Row To Max_Row
        MSFlexGrid1.Row = I%
        For J% = 0 To Max_Column
            MSFlexGrid1.Col = J%
            Select Case MSFlexGrid1.Col
                Case Column0
                    MSFlexGrid1.Text = My_Array(I% + My_Array_Pointer).Array_Column0
                Case Column1
                    MSFlexGrid1.Text = My_Array(I% + My_Array_Pointer).Array_Column1
                Case Column2
                    MSFlexGrid1.Text = My_Array(I% + My_Array_Pointer).Array_Column2
                Case Numeric_Column
                    MSFlexGrid1.Text = My_Array(I% + My_Array_Pointer).Array_Numeric_Column
                Case Column4
                    MSFlexGrid1.Text = My_Array(I% + My_Array_Pointer).Array_Column4
            End Select
        Next J%
    Next I%
    MSFlexGrid1.Visible = True
    
End Sub

Private Sub cmdOK_Click()
Dim I As Integer
Dim A As String

    Call Copy_Grid_To_Array
    'The data is in the underlaying Array - Not the grid.
    Open "C:\JJJ.TXT" For Output As #2
        For I% = First_Row To 100
            A$ = Space$(200)
            Mid$(A$, 1) = My_Array(I%).Array_Column0
            Mid$(A$, 20) = My_Array(I%).Array_Column1
            Mid$(A$, 40) = My_Array(I%).Array_Column2
            Mid$(A$, 60) = My_Array(I%).Array_Numeric_Column
            Mid$(A$, 80) = My_Array(I%).Array_Column4
            Print #2, RTrim$(A$)
        Next I%
    Close #2

    Call Start_Again
    
End Sub

Private Sub Form_Load()
Dim A As String

    Me.FontName = "Courier New"
    Me.FontSize = 10
    Me.FontBold = True
    
    A = String$(64, "H")
    CharacterWidth = TextWidth(A) / 64
    MSFlexGrid1.Clear
    
    MSFlexGrid1.Row = 0  'Put it in Fixed Row

    MSFlexGrid1.Col = Column0
    MSFlexGrid1.Text = ""
    MSFlexGrid1.ColWidth(Column0) = (CharacterWidth * 3) '2 Characters
    
    MSFlexGrid1.Col = Column1
    MSFlexGrid1.Text = "Column 1"
    MSFlexGrid1.ColWidth(Column1) = (CharacterWidth * 10) '9 Characters
       
    MSFlexGrid1.Col = Column2
    MSFlexGrid1.Text = "Column 2"
    MSFlexGrid1.ColWidth(Column2) = (CharacterWidth * 10)
    
    MSFlexGrid1.Col = Numeric_Column
    MSFlexGrid1.Text = "Numeric Column"
    MSFlexGrid1.ColWidth(Numeric_Column) = (CharacterWidth * 15) '14 Characters
    
    MSFlexGrid1.Col = Column4
    MSFlexGrid1.Text = "Column 4"
    MSFlexGrid1.ColWidth(Column4) = (CharacterWidth * 15)
       
    Call Start_Again

End Sub

Private Sub Start_Again()

    Move_Up = False
    Move_Down = False
    Move_Left = False
    Move_Right = False

    Text1.Text = ""
    Call Zero_Out_Array
    Call Copy_Array_To_Grid
    My_Array_Pointer% = 0
    Do_It = False
    VScroll1.Value = 0
    Do_It = True
    Current_Row = First_Row
    Current_Column = First_Column
    Call Move_To_Cell

End Sub

Private Sub Zero_Out_Array()
Dim I As Integer

    'Zero out the Array
    For I% = First_Row To 100
        My_Array(I%).Array_Column0 = Trim$(Str$(I%))
        My_Array(I%).Array_Column1 = ""
        My_Array(I%).Array_Column2 = ""
        My_Array(I%).Array_Numeric_Column = ""
        My_Array(I%).Array_Column4 = ""
    Next I%
    My_Array_Pointer% = 0
    
    Call Copy_Array_To_Grid
    
End Sub

Private Sub MSFlexGrid1_Click()
Dim Old_Row As Integer
Dim Old_Column As Integer
Dim New_Row As Integer
Dim New_Column As Integer

    Old_Row = Current_Row
    Old_Column = Current_Column
    
    New_Row = MSFlexGrid1.Row
    New_Column = MSFlexGrid1.Col

    MSFlexGrid1.Row = Old_Row
    MSFlexGrid1.Col = Old_Column
    'Copy the old data to the cell
    MSFlexGrid1.Text = Text1.Text
    
    MSFlexGrid1.Row = New_Row
    MSFlexGrid1.Col = New_Column
    
    Current_Row = MSFlexGrid1.Row
    Current_Column = MSFlexGrid1.Col
    
    Call Move_The_Text_Box
    
End Sub

Private Sub MSFlexGrid1_GotFocus()
    Text1.SetFocus
End Sub

Private Sub Text1_GotFocus()
Dim A As String

    If A_Numeric_Column Then
        A$ = Space$(Text1.MaxLength)
        Mid$(A$, 1) = Text1.Text
        Text1.Text = A$
        Text1.SelStart = Len(Text1.Text) - 1
    Else
        Text1.SelStart = 0
        Text1.SelLength = Len(Text1.Text)
    End If
    
End Sub

Private Sub Text1_KeyDown(KeyCode As Integer, Shift As Integer)
Dim A As String
Dim B As String

    Select Case KeyCode
        Case vbKeyReturn, vbKeyTab  'TAB or ENTER Key
            Move_Right = True
        Case vbKeyRight   'Right Arrow
            Move_Right = True
        Case vbKeyLeft    'Left arrow
            Move_Left = True
        Case vbKeyUp
            Move_Up = True
        Case vbKeyDown
            Move_Down = True
        Case Else

            If A_Numeric_Column Then
                B$ = Right$(Text1.Text, 1)
                If B$ <> "-" Then B$ = " "
                Select Case KeyCode
                    
                    Case vbKeyEscape
                        A$ = Space$(Text1.MaxLength)
                        Text1.Text = A$
                        Text1.SelStart = Len(A$) - 1
                        
                    Case 8 'Backspace
                        A$ = Space$(Text1.MaxLength)
                        Mid$(A$, 2) = Left$(Text1.Text, Text1.MaxLength - 1) & B$
                        Text1.Text = A$
                        Text1.SelStart = Len(A$)
        
        '            Case vbKeyRight   'Right Arrow
        '                Move_Right = True
        '                Text1.SelStart = Len(Text1.Text) - 2
        
                    Case 46 'Delete Key
                        If B$ = "-" Then B$ = " "
                        A$ = Space$(Text1.MaxLength)
                        Mid$(A$, 1) = Text1.Text
                        Mid$(A$, Text1.MaxLength) = B$
                        Text1.Text = A$
                        Text1.SelStart = Len(Text1.Text) - 1
                        
                    Case 48 To 57, 96 To 105, 110, 190
                        A$ = Text1.Text
                        If Len(A$) <> Text1.MaxLength Then
                            A$ = Right$("  " & A$, Text1.MaxLength - 1) & B$
                            Text1.Text = A$
                        End If
                        A$ = Space$(Text1.MaxLength - 1)
                        If InStr(Text1.Text, "3") > 0 Then
                            A$ = A$
                        End If
                        A$ = Mid$(Text1.Text, 2, Len(Text1.Text) - 1) '& B$
                        Text1.Text = A$
                        Text1.SelStart = Len(Text1.Text) - 1
                        
                    Case 189, 109 '- Minus Sign
                        A$ = Space$(Text1.MaxLength)
                        Mid$(A$, 1) = Text1.Text
                        Mid$(A$, Len(A$)) = "-"
                        Text1.Text = A$
                        Text1.SelStart = Len(Text1.Text) - 1
        
                    Case Else
                        Text1.SelStart = Len(Text1.Text) - 1
                End Select
            Else
                Select Case KeyCode
                    Case vbKeyEscape
                        Call Start_Again
                End Select
            End If
    End Select
        
    If Move_Right Or Move_Left Or Move_Up Or Move_Down Then
        Call Move_To_Cell
        MSFlexGrid1.SetFocus
        Text1.SetFocus
    End If
End Sub

Private Sub VScroll1_Change()
    If Do_It Then 'Someone moved the Scroll Bar
    
        'Take the Data in the text Box and Write it into the
        'Under Laying Cell
        MSFlexGrid1.Text = Text1.Text
    
        Call Copy_Grid_To_Array
        My_Array_Pointer% = VScroll1.Value
        Call Copy_Array_To_Grid
        
        MSFlexGrid1.Row = Current_Row
        MSFlexGrid1.Col = Current_Column

        'Put The Underlaying data in the Text.box
        Text1.Text = Trim$(MSFlexGrid1.Text)
        
        Current_Column = First_Column
        Call Move_To_Cell
    End If
End Sub

